Public Class frmMain

    Private mobjSourcePicBox As PictureBox
    Private mintNumTries As Integer
    Private mblnMatchingPicDragOK(9) As Boolean

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intX As Integer

        NewGameInit()

        Me.AllowDrop = True

        For intX = 0 To 9
            GetControlByName(Me, "picPicToMatch" & intX).AllowDrop = True
            GetControlByName(Me, "picMatchingPic" & intX).AllowDrop = True
        Next

    End Sub

    Private Sub frmMain_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter

        e.Effect = DragDropEffects.Copy

    End Sub

    Private Sub btnCheckScore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckScore.Click

        Dim intX As Integer
        Dim intNumCorrect As Integer
        Dim intPercentCorrect As Integer
        Dim strCongrats As String = ""
        Dim strTries As String
        Dim objMatchingPic As PictureBox
        Dim objMarkPic As PictureBox
        Dim objWordLabel As Label

        ' Loop thru the imgMatchingPic control array and "mark" the answer
        ' as correct or wrong ...

        For intX = 0 To 9

            objMatchingPic = DirectCast(GetControlByName(Me, "picMatchingPic" & intX), PictureBox)
            objMarkPic = DirectCast(GetControlByName(Me, "picMark" & intX), PictureBox)
            objWordLabel = DirectCast(GetControlByName(Me, "lblWord" & intX), Label)

            If objMatchingPic.Image Is Nothing Then
                ' If the picture was left blank, then mark it wrong (place
                ' the "red X" next to the image) ...
                objMarkPic.Image = picWrong.Image
            ElseIf objMatchingPic.Tag = objWordLabel.Text Then
                ' If the Tag of the image that was dropped into the slot
                ' matches the caption of the corresponding element of the
                ' lblWord Label control array, then mark it correct (place
                ' the green checkmark next to the image) and increment the
                ' counter for the number of correct answers.
                objMarkPic.Image = picCorrect.Image
                intNumCorrect = intNumCorrect + 1
            Else
                ' The Tag of the image that was dropped into the slot does
                ' NOT match the caption of the corresponding element of the
                ' lblWord Label control array, so mark it wrong (place
                ' the "red X" next to the image) ...
                objMarkPic.Image = picWrong.Image
            End If
            ' Disable automatic dragging for the moment by setting the DragMode
            ' to Manual ...
            mblnMatchingPicDragOK(intX) = False
            'imgMatchingPic(intX).DragMode = vbManual
        Next

        ' Increment the number of tries for this game ...
        mintNumTries = mintNumTries + 1

        ' Calculate the percent correct ...
        intPercentCorrect = (intNumCorrect / 10) * 100

        ' Formulate a message indicating how many answers are correct and in how
        ' many tries ...
        If mintNumTries = 1 Then
            strTries = "try"
            If intPercentCorrect = 100 Then
                strCongrats = "Congratulations! "
            End If
        Else
            strTries = "tries"
        End If

        Beep()

        lblScoreMessage.Visible = True
        lblScoreMessage.Text = strCongrats & "You scored " & _
                               intPercentCorrect & "% in " & mintNumTries & _
                               " " & strTries & "."

        ' If the user did not get a perfect score, make the Reset button visible
        ' so they can go back and correct the answers they got wrong ...
        If intPercentCorrect < 100 Then
            btnReset.Visible = True
        Else
            btnReset.Visible = False
        End If

    End Sub

    Private Sub btnReset_Click(ByVal sender As System.Object, _
                               ByVal e As System.EventArgs) _
    Handles btnReset.Click

        Dim intX As Integer
        Dim intY As Integer
        Dim objMatchingPic As PictureBox
        Dim objMarkPic As PictureBox
        Dim objWordLabel As Label
        Dim objPicToMatch As PictureBox

        ' Loop thru the imgMatchingPic control array ...
        For intX = 0 To 9

            objMatchingPic = DirectCast(GetControlByName(Me, "picMatchingPic" & intX), PictureBox)
            objMarkPic = DirectCast(GetControlByName(Me, "picMark" & intX), PictureBox)
            objWordLabel = DirectCast(GetControlByName(Me, "lblWord" & intX), Label)

            ' If the user got the answer wrong ...
            If objMatchingPic.Tag <> objWordLabel.Text Then
                ' If they left the image blank, then just clear the "red X" mark ...
                If objMatchingPic.Image Is Nothing Then
                    objMarkPic.Image = Nothing
                Else
                    ' Otherwise, move the picture back to its original slot on the
                    ' left and clear it from the wrong slot on the right ...
                    For intY = 0 To 9
                        objPicToMatch = DirectCast(GetControlByName(Me, "picPicToMatch" & intY), PictureBox)
                        If objPicToMatch.Tag = objMatchingPic.Tag Then
                            objPicToMatch.Image = objMatchingPic.Image
                            objMatchingPic.Image = Nothing
                            objMarkPic.Image = Nothing
                            Exit For
                        End If
                    Next
                End If
                ' Set the DragMode for this slot back to Automatic ...
                mblnMatchingPicDragOK(intX) = True
            End If
        Next

        ' Remove the Reset button from the screen at this time ...
        btnReset.Visible = False

    End Sub

    Private Sub btnNewGame_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewGame.Click

        Dim intX As Integer

        ' Clear the "marks" as well as the images in the right-hand column ...
        For intX = 0 To 9
            DirectCast(GetControlByName(Me, "picMark" & intX), PictureBox).Image = Nothing
            DirectCast(GetControlByName(Me, "picMatchingPic" & intX), PictureBox).Image = Nothing
        Next intX

        ' Reset number of tries counter ...
        mintNumTries = 0

        ' Prepare for a new game ...
        Call NewGameInit()

        ' Make the "Check Score" button the default button ...
        btnCheckScore.Focus()

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click

        Me.Close()

    End Sub

    Private Sub PicBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
    Handles picPicToMatch0.MouseDown, _
            picPicToMatch1.MouseDown, _
            picPicToMatch2.MouseDown, _
            picPicToMatch3.MouseDown, _
            picPicToMatch4.MouseDown, _
            picPicToMatch5.MouseDown, _
            picPicToMatch6.MouseDown, _
            picPicToMatch7.MouseDown, _
            picPicToMatch8.MouseDown, _
            picPicToMatch9.MouseDown, _
            picMatchingPic0.MouseDown, _
            picMatchingPic1.MouseDown, _
            picMatchingPic2.MouseDown, _
            picMatchingPic3.MouseDown, _
            picMatchingPic4.MouseDown, _
            picMatchingPic5.MouseDown, _
            picMatchingPic6.MouseDown, _
            picMatchingPic7.MouseDown, _
            picMatchingPic8.MouseDown, _
            picMatchingPic9.MouseDown

        Dim strRootPicBoxName As String
        Dim intMatchingPicIndex As Integer

        If sender.Image Is Nothing Then Exit Sub

        strRootPicBoxName = Strings.Left(sender.name, Len(sender.name) - 1)
        intMatchingPicIndex = CInt(Strings.Right(sender.name, 1))

        If strRootPicBoxName = "picPicToMatch" _
        OrElse mblnMatchingPicDragOK(intMatchingPicIndex) Then

            mobjSourcePicBox = DirectCast(sender, PictureBox)

            mobjSourcePicBox.DoDragDrop(sender.Image, DragDropEffects.Copy)
        End If

    End Sub

    Private Sub PicBox_GiveFeedback(ByVal sender As Object, ByVal e As System.Windows.Forms.GiveFeedbackEventArgs) _
    Handles picPicToMatch0.GiveFeedback, _
            picPicToMatch1.GiveFeedback, _
            picPicToMatch2.GiveFeedback, _
            picPicToMatch3.GiveFeedback, _
            picPicToMatch4.GiveFeedback, _
            picPicToMatch5.GiveFeedback, _
            picPicToMatch6.GiveFeedback, _
            picPicToMatch7.GiveFeedback, _
            picPicToMatch8.GiveFeedback, _
            picPicToMatch9.GiveFeedback, _
            picMatchingPic0.GiveFeedback, _
            picMatchingPic1.GiveFeedback, _
            picMatchingPic2.GiveFeedback, _
            picMatchingPic3.GiveFeedback, _
            picMatchingPic4.GiveFeedback, _
            picMatchingPic5.GiveFeedback, _
            picMatchingPic6.GiveFeedback, _
            picMatchingPic7.GiveFeedback, _
            picMatchingPic8.GiveFeedback, _
            picMatchingPic9.GiveFeedback

        e.UseDefaultCursors = False

        If ((e.Effect And DragDropEffects.Copy) = DragDropEffects.Copy) Then
            Windows.Forms.Cursor.Current = New Cursor(GetIconFromImage(mobjSourcePicBox.Image).Handle)
        Else
            Cursor.Current = System.Windows.Forms.Cursors.Default
        End If

    End Sub

    Private Sub PicBox_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles picMatchingPic0.DragEnter, _
            picMatchingPic1.DragEnter, _
            picMatchingPic2.DragEnter, _
            picMatchingPic3.DragEnter, _
            picMatchingPic4.DragEnter, _
            picMatchingPic5.DragEnter, _
            picMatchingPic6.DragEnter, _
            picMatchingPic7.DragEnter, _
            picMatchingPic8.DragEnter, _
            picMatchingPic9.DragEnter, _
            picPicToMatch0.DragEnter, _
            picPicToMatch1.DragEnter, _
            picPicToMatch2.DragEnter, _
            picPicToMatch3.DragEnter, _
            picPicToMatch4.DragEnter, _
            picPicToMatch5.DragEnter, _
            picPicToMatch6.DragEnter, _
            picPicToMatch7.DragEnter, _
            picPicToMatch8.DragEnter, _
            picPicToMatch9.DragEnter

        ' This procedure verifies whether our destination control can handle the
        ' intended data while dragging over

        If e.Data().GetDataPresent(DataFormats.Bitmap) Then
            e.Effect() = DragDropEffects.Copy
        Else
            e.Effect() = DragDropEffects.None
        End If

    End Sub

    Private Sub PicBox_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles picMatchingPic0.DragDrop, _
            picMatchingPic1.DragDrop, _
            picMatchingPic2.DragDrop, _
            picMatchingPic3.DragDrop, _
            picMatchingPic4.DragDrop, _
            picMatchingPic5.DragDrop, _
            picMatchingPic6.DragDrop, _
            picMatchingPic7.DragDrop, _
            picMatchingPic8.DragDrop, _
            picMatchingPic9.DragDrop, _
            picPicToMatch0.DragDrop, _
            picPicToMatch1.DragDrop, _
            picPicToMatch2.DragDrop, _
            picPicToMatch3.DragDrop, _
            picPicToMatch4.DragDrop, _
            picPicToMatch5.DragDrop, _
            picPicToMatch6.DragDrop, _
            picPicToMatch7.DragDrop, _
            picPicToMatch8.DragDrop, _
            picPicToMatch9.DragDrop

        If Not (sender.Image Is Nothing) Then Exit Sub

        'This procedure receives the dragged data once it passes the 
        ' data verification handled by the DragEnter method

        'Drops the data onto the destination control
        sender.Image = e.Data().GetData(DataFormats.Bitmap)
        sender.Tag = mobjSourcePicBox.Tag
        mobjSourcePicBox.Image = Nothing

    End Sub


    Private Sub NewGameInit()

        Dim blnNumberExists As Boolean
        Dim intRandomNumber As Integer
        Dim aintPicIndex(9) As Integer
        Dim aintWordIndex(9) As Integer
        Dim intX As Integer
        Dim intY As Integer

        'Reseed the VB's random number generator
        Randomize()

        'Set the 10 pictures that will be used in this game ...

        For intX = 0 To 9

            ' Get a random number between 0 and 24, make sure it is not
            ' one we already have ...
            Do
                intRandomNumber = GetRandomNumber(0, 24)
                blnNumberExists = False
                intY = 0

                Do Until intY >= intX Or blnNumberExists
                    If intRandomNumber = aintPicIndex(intY) Then
                        blnNumberExists = True
                    Else
                        intY = intY + 1
                    End If
                Loop

            Loop While blnNumberExists

            ' Store the new random number in the aintPicIndex array, so we
            ' can check for the next go-round ...
            aintPicIndex(intX) = intRandomNumber

            ' Load the picture from the source image array to the
            ' current set for this game ...
            DirectCast(GetControlByName(Me, "picPicToMatch" & intX), PictureBox).Image _
                    = DirectCast(GetControlByName(Me, "picSourcePic" & intRandomNumber), PictureBox).Image
            GetControlByName(Me, "picPicToMatch" & intX).Tag _
                    = GetControlByName(Me, "picSourcePic" & intRandomNumber).Tag

            ' set the image's drag icon to match its picture
            'imgPicToMatch(intX).DragIcon = imgPicToMatch(intX).Picture

            ' allow automatic dragging
            'imgMatchingPic(intX).DragMode = vbAutomatic
            mblnMatchingPicDragOK(intX) = True

        Next intX

        ' Using the Tag property of the 10 images to be used in this game, "mix 'em up" and
        ' set the "word" label that appears to the right of the second column of images.

        For intX = 0 To 9
            Do
                intRandomNumber = GetRandomNumber(0, 9)
                blnNumberExists = False
                intY = 0
                Do Until intY >= intX Or blnNumberExists
                    If intRandomNumber = aintWordIndex(intY) Then
                        blnNumberExists = True
                    Else
                        intY = intY + 1
                    End If
                Loop
            Loop While blnNumberExists
            aintWordIndex(intX) = intRandomNumber
            GetControlByName(Me, "lblWord" & intX).Text _
                = GetControlByName(Me, "picPicToMatch" & intRandomNumber).Tag
        Next intX

        ' No need to see the "scoring box" or Reset button at this time ...
        lblScoreMessage.Visible = False
        btnReset.Visible = False

    End Sub


    Private Function GetRandomNumber(ByVal pintLowerBound As Integer, _
                                     ByVal pintUpperBound As Integer) _
    As Integer

        ' This function will return a random integer that falls with the range
        ' of the two arguments passed.

        GetRandomNumber = Int((pintUpperBound - pintLowerBound + 1) * Rnd() + pintLowerBound)

    End Function

    Private Function GetControlByName(ByVal pobjParent As Control, ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

    Public Function GetIconFromImage(ByVal pobjImage As Image) As Icon

        Dim bmp As Bitmap

        bmp = pobjImage

        Return (Drawing.Icon.FromHandle(bmp.GetHicon))

    End Function

End Class